{-# LANGUAGE OverloadedStrings #-}
module SlashRedirect where

import Test.Tasty (TestTree, defaultMain, testGroup)
import Test.Tasty.HUnit ((@?=), testCase)
import Nero
import Nero.Application (slashRedirect)

app :: Request -> Maybe Response
app request = request ^? _GET
          >>= slashRedirect (prefixed "/hello/" . suffixed "/")
                            (\name -> ok $ "<h1>Hello " <> name <> "</h1>")

tests :: TestTree
tests = testGroup "SlashRedirect"
    [ testCase "withSlash"
          $ run "/hello/there/"
        @?= Just (ok "<h1>Hello there</h1>")
    , testCase "withoutSlash"
          $ run "/hello/there"
        @?= Just (movedPermanently $ dummyUrl & path .~ "/hello/there/")
    , testCase "NoMatch"
          $ run "/bye/there"
        @?= Nothing
    ]
  where
    run p = app $ dummyRequest & path .~ p

main :: IO ()
main = defaultMain tests
